<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: io/writedatadat.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_7dc76e12c3f74bb85b7effb3b7dc07e4.html">io</a>
  </div>
</div>
<div class="contents">
<h1>writedatadat.c</h1><a href="writedatadat_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: writedatadat.c 3051 2010-04-14 17:58:54Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="magpario_8h.html">magpario.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#include &quot;addons/addons.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#endif</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00033"></a><a class="code" href="writedatadat_8c.html#ad28639d44673a3d4c835d2390bf74c29">00033</a> <span class="preprocessor">#define NVDATA 18</span>
<a name="l00034"></a><a class="code" href="writedatadat_8c.html#ae821231396164e33ec42f01e154f5e3c">00034</a> <span class="preprocessor"></span><span class="preprocessor">#define NEDATA  1</span>
<a name="l00035"></a><a class="code" href="writedatadat_8c.html#a36b5a0a7c9d9a2c0e0060a859ae15269">00035</a> <span class="preprocessor"></span><span class="preprocessor">#define NEDATA2 0</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span>
<a name="l00037"></a>00037 <span class="keyword">static</span> <span class="keywordtype">int</span>  doinit=1;
<a name="l00038"></a>00038 <span class="keyword">static</span> Mat  AIpolline; 
<a name="l00039"></a>00039 <span class="keyword">static</span> Vec  VIpolline; 
<a name="l00042"></a><a class="code" href="writedatadat_8c.html#a27c977d96cd920cf08c4c10eb3565f10">00042</a> <span class="keywordtype">int</span> <a class="code" href="writedatadat_8c.html#a27c977d96cd920cf08c4c10eb3565f10">WriteDatInit</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044   <span class="keywordtype">int</span>         i,j,k,l;
<a name="l00045"></a>00045 
<a name="l00046"></a>00046   <span class="keywordtype">int</span>         nmax;
<a name="l00047"></a>00047   PetscTruth  flg;
<a name="l00048"></a>00048 
<a name="l00049"></a>00049   <span class="keywordtype">int</span>         res;
<a name="l00050"></a>00050   PetscReal   *vertxyz2;
<a name="l00051"></a>00051   PetscReal   line_p[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>], line_v[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   PetscReal   axes2[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00054"></a>00054 
<a name="l00055"></a>00055   <span class="keywordtype">int</span>         cnt,*sliceele;
<a name="l00056"></a>00056   PetscReal   sgnx,sgny;
<a name="l00057"></a>00057   PetscReal   x2min[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>]={0,0,PETSC_MAX};
<a name="l00058"></a>00058   PetscReal   x2max[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>]={0,0,PETSC_MIN};
<a name="l00059"></a>00059   PetscReal   xmin[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>],xmax[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00060"></a>00060   PetscReal   line_length;
<a name="l00061"></a>00061   PetscReal   *d,p[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00062"></a>00062   PetscReal   rhs[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00063"></a>00063   <span class="keywordtype">int</span>         t_ele;
<a name="l00064"></a>00064 
<a name="l00065"></a>00065   PetscReal   matele;
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="keywordtype">int</span> rank,size;
<a name="l00071"></a>00071   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00072"></a>00072   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   ierr = PetscMalloc(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>*<span class="keyword">sizeof</span>(PetscReal),&amp;vertxyz2);CHKERRQ(ierr);
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   nmax=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00077"></a>00077   ierr = PetscOptionsGetRealArray(PETSC_NULL,<span class="stringliteral">&quot;-line_p&quot;</span>,line_p,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;nmax,&amp;flg);CHKERRQ(ierr);
<a name="l00078"></a>00078   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00079"></a>00079     line_p[0]=line_p[1]=line_p[2]=PETSC_MAX;
<a name="l00080"></a>00080     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00081"></a>00081       <span class="stringliteral">&quot;Option -line_p not found, using default value: (%g,%g,%g)\n&quot;</span>,
<a name="l00082"></a>00082       line_p[0],line_p[1],line_p[2]
<a name="l00083"></a>00083     );
<a name="l00084"></a>00084     nmax=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00085"></a>00085   }
<a name="l00086"></a>00086   <span class="keywordflow">if</span> (nmax!=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>)
<a name="l00087"></a>00087     SETERRQ(PETSC_ERR_ARG_INCOMP,<span class="stringliteral">&quot;Wrong number of values for option -line_p!\n&quot;</span>);
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   nmax=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00090"></a>00090   ierr = PetscOptionsGetRealArray(PETSC_NULL,<span class="stringliteral">&quot;-line_v&quot;</span>,line_v,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;nmax,&amp;flg);CHKERRQ(ierr);
<a name="l00091"></a>00091   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00092"></a>00092     line_v[0]=1;line_v[1]=line_v[2]=0;
<a name="l00093"></a>00093     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00094"></a>00094       <span class="stringliteral">&quot;Option -line_v not found, using default value: (%g,%g,%g)\n&quot;</span>,
<a name="l00095"></a>00095       line_v[0],line_v[1],line_v[2]
<a name="l00096"></a>00096     );
<a name="l00097"></a>00097     nmax=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00098"></a>00098   }
<a name="l00099"></a>00099   <span class="keywordflow">if</span> (nmax!=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>)
<a name="l00100"></a>00100     SETERRQ(PETSC_ERR_ARG_INCOMP,<span class="stringliteral">&quot;Wrong number of values for option -line_v!\n&quot;</span>);
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00103"></a>00103     <span class="stringliteral">&quot;sampling line: (x,y,z)=(%g,%g,%g)+n*(%g,%g,%g)\n&quot;</span>,
<a name="l00104"></a>00104     line_p[0],line_p[1],line_p[2],
<a name="l00105"></a>00105     line_v[0],line_v[1],line_v[2]
<a name="l00106"></a>00106   );
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   <span class="comment">/* calculate unit vector */</span>
<a name="l00109"></a>00109   PetscReal nrm;
<a name="l00110"></a>00110   nrm=1.0/<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,line_v,1);
<a name="l00111"></a>00111   <a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">my_dscal</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,nrm,line_v,1);
<a name="l00112"></a>00112   <span class="comment">/* this gives incorrect line_v (!!!): my_dscal(ND,1.0/my_dnrm2(ND,line_v,1),line_v,1); */</span>
<a name="l00113"></a>00113 
<a name="l00114"></a>00114   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00115"></a>00115     <span class="stringliteral">&quot;normalized sampling line vector: (%g,%g,%g)\n&quot;</span>,
<a name="l00116"></a>00116     line_v[0],line_v[1],line_v[2]
<a name="l00117"></a>00117   );
<a name="l00118"></a>00118 
<a name="l00119"></a>00119   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;shift and tilt to avoid cutting &#39;between&#39; elements\n&quot;</span>);
<a name="l00120"></a>00120 <span class="preprocessor">#define DIST 1e-12</span>
<a name="l00121"></a>00121 <span class="preprocessor"></span>  line_p[0]+=<a class="code" href="writedatadat_8c.html#ab8a17bd7aebfe396839620a814ec3e4d">DIST</a>;line_v[0]+=<a class="code" href="writedatadat_8c.html#ab8a17bd7aebfe396839620a814ec3e4d">DIST</a>;
<a name="l00122"></a>00122   line_p[1]+=<a class="code" href="writedatadat_8c.html#ab8a17bd7aebfe396839620a814ec3e4d">DIST</a>;line_v[1]+=<a class="code" href="writedatadat_8c.html#ab8a17bd7aebfe396839620a814ec3e4d">DIST</a>;
<a name="l00123"></a>00123   line_p[2]+=<a class="code" href="writedatadat_8c.html#ab8a17bd7aebfe396839620a814ec3e4d">DIST</a>;line_v[2]+=<a class="code" href="writedatadat_8c.html#ab8a17bd7aebfe396839620a814ec3e4d">DIST</a>;
<a name="l00124"></a>00124   <a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">my_dscal</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1.0+<a class="code" href="writedatadat_8c.html#ab8a17bd7aebfe396839620a814ec3e4d">DIST</a>,line_v,1);
<a name="l00125"></a>00125   <a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">my_dscal</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1.0+<a class="code" href="writedatadat_8c.html#ab8a17bd7aebfe396839620a814ec3e4d">DIST</a>,line_p,1);
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   <span class="comment">/* line_v will be z-axes in axes2 coordinates */</span>
<a name="l00128"></a>00128   <a class="code" href="axesrot_8c.html#a55381bb85270f2885891ae5fcfa61369">AxesRotation</a>(line_p,line_v,axes2,0,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>,vertxyz2);
<a name="l00129"></a>00129 
<a name="l00130"></a>00130   ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;sliceele);CHKERRQ(ierr);
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   cnt=0;
<a name="l00133"></a>00133   <span class="keywordflow">for</span> (i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>;i++) {
<a name="l00134"></a>00134     <span class="comment">/* get x- and y-coordinate of first vertex */</span>
<a name="l00135"></a>00135     sgnx=vertxyz2[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*i+0]+0];
<a name="l00136"></a>00136     sgny=vertxyz2[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*i+0]+1];
<a name="l00137"></a>00137 
<a name="l00138"></a>00138     <span class="keywordflow">for</span> (j=1;j&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;j++) {
<a name="l00139"></a>00139       <span class="keywordflow">if</span> (sgnx*vertxyz2[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+j]+0] &lt;= 0.0) <span class="keywordflow">break</span>;
<a name="l00140"></a>00140     }
<a name="l00141"></a>00141     <span class="keywordflow">if</span> (j&lt;NV) {
<a name="l00142"></a>00142       <span class="keywordflow">for</span> (j=1;j&lt;NV;j++) {
<a name="l00143"></a>00143         <span class="comment">/* multiply with other y-coordinate of other vertices</span>
<a name="l00144"></a>00144 <span class="comment">           if (product &lt; 0) then they have opposite signs and</span>
<a name="l00145"></a>00145 <span class="comment">           the element must be cut by the sampling line</span>
<a name="l00146"></a>00146 <span class="comment">        */</span>
<a name="l00147"></a>00147         <span class="keywordflow">if</span> (sgny*vertxyz2[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+j]+1] &lt;= 0.0) <span class="keywordflow">break</span>;
<a name="l00148"></a>00148       }
<a name="l00149"></a>00149       <span class="comment">/* if an element cut by the sampling line has been found */</span>
<a name="l00150"></a>00150       <span class="keywordflow">if</span> (j&lt;NV) {
<a name="l00151"></a>00151         <span class="comment">/* add its local index to the array */</span>
<a name="l00152"></a>00152         sliceele[cnt++]=i;
<a name="l00153"></a>00153       }
<a name="l00154"></a>00154     }
<a name="l00155"></a>00155   }
<a name="l00156"></a>00156   PetscSynchronizedPrintf(PETSC_COMM_WORLD,
<a name="l00157"></a>00157     <span class="stringliteral">&quot;&lt;%i&gt;Found %i elements cut by sampling line\n&quot;</span>,
<a name="l00158"></a>00158     rank,cnt
<a name="l00159"></a>00159   );
<a name="l00160"></a>00160   PetscSynchronizedFlush(PETSC_COMM_WORLD);
<a name="l00161"></a>00161 
<a name="l00162"></a>00162   <span class="keywordtype">int</span> sum;
<a name="l00163"></a>00163   ierr=MPI_Allreduce((<span class="keywordtype">int</span>*)&amp;cnt,(<span class="keywordtype">int</span>*)&amp;sum,1,MPI_INT,MPI_SUM,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00164"></a>00164   <span class="keywordflow">if</span> (sum==0) {
<a name="l00165"></a>00165     AIpolline=PETSC_NULL;
<a name="l00166"></a>00166 
<a name="l00167"></a>00167     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00168"></a>00168       <span class="stringliteral">&quot;Sampling line outside the FE mesh.\nNo *.d files will be stored!\n&quot;</span>
<a name="l00169"></a>00169     );
<a name="l00170"></a>00170 
<a name="l00171"></a>00171     ierr = PetscFree(sliceele);CHKERRQ(ierr);
<a name="l00172"></a>00172     ierr = PetscFree(vertxyz2);CHKERRQ(ierr);
<a name="l00173"></a>00173 
<a name="l00174"></a>00174     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00175"></a>00175   }
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   <span class="comment">/* get number of pixels */</span>
<a name="l00178"></a>00178   ierr=MPI_Allreduce((<span class="keywordtype">int</span>*)&amp;cnt,(<span class="keywordtype">int</span>*)&amp;res,1,MPI_INT,MPI_SUM,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00179"></a>00179   res*=5;
<a name="l00180"></a>00180 
<a name="l00181"></a>00181   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;sampling points: %i\n&quot;</span>,res);
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   <span class="comment">/* find bbox of probing line in axes2 coordinates */</span>
<a name="l00184"></a>00184   <span class="keywordflow">for</span> (i=0;i&lt;cnt;i++) {
<a name="l00185"></a>00185     <span class="keywordflow">for</span> (j=0;j&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;j++) {
<a name="l00186"></a>00186       x2min[2]=PetscMin(x2min[2],vertxyz2[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*sliceele[i]+j]+2]);
<a name="l00187"></a>00187       x2max[2]=PetscMax(x2max[2],vertxyz2[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*sliceele[i]+j]+2]);
<a name="l00188"></a>00188     }
<a name="l00189"></a>00189   }
<a name="l00190"></a>00190 
<a name="l00191"></a>00191   ierr = PetscGlobalMin(&amp;x2min[2],&amp;xmin[2],PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00192"></a>00192   x2min[2]=xmin[2];
<a name="l00193"></a>00193   ierr = PetscGlobalMax(&amp;x2max[2],&amp;xmax[2],PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00194"></a>00194   x2max[2]=xmax[2];
<a name="l00195"></a>00195 
<a name="l00196"></a>00196   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00197"></a>00197     <span class="stringliteral">&quot;sampling line ends in local coordinates (axes2):\n&quot;</span>
<a name="l00198"></a>00198     <span class="stringliteral">&quot;(%g,%g,%g) (%g,%g,%g)\n&quot;</span>,
<a name="l00199"></a>00199     x2min[0],x2min[1],x2min[2],
<a name="l00200"></a>00200     x2max[0],x2max[1],x2max[2]
<a name="l00201"></a>00201   );
<a name="l00202"></a>00202 
<a name="l00203"></a>00203   <span class="comment">/* add a little space on both ends */</span>
<a name="l00204"></a>00204   x2min[2] -= 1.0*(x2max[2]-x2min[2])/(res);
<a name="l00205"></a>00205   x2max[2] += 2.0*(x2max[2]-x2min[2])/(res);
<a name="l00206"></a>00206   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00207"></a>00207     <span class="stringliteral">&quot;enlarged slice corners in local slice plane coordinates (axes2):\n&quot;</span>
<a name="l00208"></a>00208     <span class="stringliteral">&quot;(%g,%g,%g) (%g,%g,%g)\n&quot;</span>,
<a name="l00209"></a>00209     x2min[0],x2min[1],x2min[2],
<a name="l00210"></a>00210     x2max[0],x2max[1],x2max[2]
<a name="l00211"></a>00211   );
<a name="l00212"></a>00212   <span class="comment">/* get length of slice edges */</span>
<a name="l00213"></a>00213   line_length=x2max[2]-x2min[2];
<a name="l00214"></a>00214 
<a name="l00215"></a>00215   <span class="comment">/* find bbox of cut probing line in axes coordinates (rotate back) */</span>
<a name="l00216"></a>00216   <a class="code" href="axesrot_8c.html#a55381bb85270f2885891ae5fcfa61369">AxesRotation</a>(line_p,PETSC_NULL,axes2,1,1,x2min,xmin);
<a name="l00217"></a>00217   <a class="code" href="axesrot_8c.html#a55381bb85270f2885891ae5fcfa61369">AxesRotation</a>(line_p,PETSC_NULL,axes2,1,1,x2max,xmax);
<a name="l00218"></a>00218 
<a name="l00219"></a>00219   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00220"></a>00220     <span class="stringliteral">&quot;sampling line ends in world coordinates (axes):\n&quot;</span>
<a name="l00221"></a>00221     <span class="stringliteral">&quot;(%g,%g,%g) (%g,%g,%g)\n&quot;</span>,
<a name="l00222"></a>00222     xmin[0],xmin[1],xmin[2],
<a name="l00223"></a>00223     xmax[0],xmax[1],xmax[2]
<a name="l00224"></a>00224   );
<a name="l00225"></a>00225 
<a name="l00226"></a>00226   <span class="keywordflow">if</span> (!rank) {
<a name="l00227"></a>00227     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;length of sampling line: %g\n&quot;</span>,line_length);
<a name="l00228"></a>00228 
<a name="l00229"></a>00229     <span class="keywordtype">char</span> fmesh[256];
<a name="l00230"></a>00230     FILE *fd;
<a name="l00231"></a>00231     ierr = PetscSNPrintf(fmesh,255,<span class="stringliteral">&quot;%s.%04i.datmsh&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a2fba16fa768b0451df8fd12ed00a6c6b">simname</a>,gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>);CHKERRQ(ierr);
<a name="l00232"></a>00232     ierr = PetscFOpen(PETSC_COMM_WORLD,fmesh,<span class="stringliteral">&quot;w&quot;</span>,&amp;fd);CHKERRQ(ierr);
<a name="l00233"></a>00233     <span class="keywordflow">if</span> (!fd) {
<a name="l00234"></a>00234       SETERRQ1(PETSC_ERR_FILE_OPEN,<span class="stringliteral">&quot;Cannot open %s\n&quot;</span>,fmesh);
<a name="l00235"></a>00235     }
<a name="l00236"></a>00236     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Opening file %s\n&quot;</span>,fmesh);
<a name="l00237"></a>00237 
<a name="l00238"></a>00238     ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,
<a name="l00239"></a>00239       <span class="stringliteral">&quot;#.%4s %14s %14s %14s %14s\n&quot;</span>
<a name="l00240"></a>00240       <span class="stringliteral">&quot;#.%4s %14s %14s %14s %14s\n&quot;</span>,
<a name="l00241"></a>00241       <span class="stringliteral">&quot;..id&quot;</span>,<span class="stringliteral">&quot;dist&quot;</span>,<span class="stringliteral">&quot;x&quot;</span>,<span class="stringliteral">&quot;y&quot;</span>,<span class="stringliteral">&quot;z&quot;</span>,
<a name="l00242"></a>00242       <span class="stringliteral">&quot;...-&quot;</span>,<span class="stringliteral">&quot;-&quot;</span>,<span class="stringliteral">&quot;-&quot;</span>,<span class="stringliteral">&quot;-&quot;</span>,<span class="stringliteral">&quot;-&quot;</span>
<a name="l00243"></a>00243     );CHKERRQ(ierr);
<a name="l00244"></a>00244 
<a name="l00245"></a>00245     <span class="keywordflow">for</span> (i=0;i&lt;res;i++) {
<a name="l00246"></a>00246       <span class="comment">/* calculate xyz coordinates of pixel */</span>
<a name="l00247"></a>00247       <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,xmin,1,p,1);
<a name="l00248"></a>00248       <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,i*line_length/res,axes2+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*2,1,p,1);
<a name="l00249"></a>00249 
<a name="l00250"></a>00250       ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,
<a name="l00251"></a>00251         <span class="stringliteral">&quot;  %4d %14e %14e %14e %14e\n&quot;</span>,
<a name="l00252"></a>00252         i,i*line_length/res,
<a name="l00253"></a>00253         p[0],p[1],p[2]
<a name="l00254"></a>00254       );
<a name="l00255"></a>00255     }
<a name="l00256"></a>00256 
<a name="l00257"></a>00257     ierr = PetscFClose(PETSC_COMM_WORLD,fd);CHKERRQ(ierr);
<a name="l00258"></a>00258   }
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 
<a name="l00261"></a>00261   <span class="comment">/* why &quot;MatAssemblyEnd_SeqAIJMaximum nonzeros in any row is 5&quot; ? */</span>
<a name="l00262"></a>00262   <span class="keywordflow">if</span> (!rank) {
<a name="l00263"></a>00263     ierr = MatCreateMPIAIJ(
<a name="l00264"></a>00264       PETSC_COMM_WORLD,
<a name="l00265"></a>00265       <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*res,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,
<a name="l00266"></a>00266       <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*res,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,
<a name="l00267"></a>00267       <a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>+1,PETSC_NULL,<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>+1,PETSC_NULL,
<a name="l00268"></a>00268       &amp;AIpolline
<a name="l00269"></a>00269     );CHKERRQ(ierr);
<a name="l00270"></a>00270   }
<a name="l00271"></a>00271   <span class="keywordflow">else</span> {
<a name="l00272"></a>00272     ierr = MatCreateMPIAIJ(
<a name="l00273"></a>00273       PETSC_COMM_WORLD,
<a name="l00274"></a>00274       0,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,
<a name="l00275"></a>00275       <a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*res,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,
<a name="l00276"></a>00276       <a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>,PETSC_NULL,<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>,PETSC_NULL,
<a name="l00277"></a>00277       &amp;AIpolline
<a name="l00278"></a>00278     );CHKERRQ(ierr);
<a name="l00279"></a>00279   }
<a name="l00280"></a>00280   ierr = MatSetFromOptions(AIpolline);CHKERRQ(ierr);
<a name="l00281"></a>00281 
<a name="l00282"></a>00282   <span class="keywordflow">if</span> (cnt&gt;0) {
<a name="l00283"></a>00283     t_ele=sliceele[0];
<a name="l00284"></a>00284     d=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*t_ele+3];
<a name="l00285"></a>00285 
<a name="l00286"></a>00286     <span class="keywordflow">for</span> (i=0;i&lt;res;i++) {
<a name="l00287"></a>00287       <span class="comment">/* calculate xyz coordinates of pixel */</span>
<a name="l00288"></a>00288 
<a name="l00289"></a>00289       <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,xmin,1,p,1);
<a name="l00290"></a>00290       <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,i*line_length/res,axes2+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*2,1,p,1);
<a name="l00291"></a>00291 
<a name="l00292"></a>00292       <span class="comment">/* find the tetrahedron, in which it is located */</span>
<a name="l00293"></a>00293       <span class="keywordflow">for</span> (k=-1;k&lt;cnt;k++) {
<a name="l00294"></a>00294         <span class="comment">/* let&#39;s try with the element t_ele of our predecessor</span>
<a name="l00295"></a>00295 <span class="comment">           first (k==-1) (we are close for sure!)</span>
<a name="l00296"></a>00296 <span class="comment">        */</span>
<a name="l00297"></a>00297         <span class="keywordflow">if</span> (k&gt;=0) {
<a name="l00298"></a>00298           t_ele=sliceele[k];
<a name="l00299"></a>00299           d=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*t_ele+3];
<a name="l00300"></a>00300         }
<a name="l00301"></a>00301 
<a name="l00302"></a>00302         <span class="comment">/* calculate barycentric coordinates</span>
<a name="l00303"></a>00303 <span class="comment">           info from: 3Ddata.pdf</span>
<a name="l00304"></a>00304 <span class="comment">           Course in4008 - Data Visualization</span>
<a name="l00305"></a>00305 <span class="comment">           http://visualization.tudelft.nl/frits.html</span>
<a name="l00306"></a>00306 <span class="comment">        */</span>
<a name="l00307"></a>00307 
<a name="l00308"></a>00308         <span class="comment">/* calculate rhs=p-d */</span>
<a name="l00309"></a>00309         <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,p,1,rhs,1);
<a name="l00310"></a>00310         <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,-1.0,d,1,rhs,1);
<a name="l00311"></a>00311 
<a name="l00312"></a>00312         <span class="comment">/* skip element, if we are too far away */</span>
<a name="l00313"></a>00313         <span class="keywordflow">if</span> (<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,rhs,1)&gt;gdata-&gt;<a class="code" href="structGridData.html#a221b259fa149eef6f0982c2b6c9629f2">elenmax</a>) <span class="keywordflow">continue</span>;
<a name="l00314"></a>00314 
<a name="l00315"></a>00315         <span class="keywordflow">if</span> (
<a name="l00316"></a>00316           <a class="code" href="barycent_8c.html#ac3e1493d687d06e1258e781a9fdf5a90">barycent</a>(
<a name="l00317"></a>00317             p,
<a name="l00318"></a>00318             gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*t_ele+0],
<a name="l00319"></a>00319             gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*t_ele+1],
<a name="l00320"></a>00320             gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*t_ele+2],
<a name="l00321"></a>00321             gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*t_ele+3],
<a name="l00322"></a>00322             rhs
<a name="l00323"></a>00323           )
<a name="l00324"></a>00324         ) {
<a name="l00325"></a>00325           <span class="keywordflow">for</span> (l=0;l&lt;<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;l++) {
<a name="l00326"></a>00326             matele=(1-rhs[0]-rhs[1]-rhs[2]);
<a name="l00327"></a>00327             ierr = MatSetValue(AIpolline,
<a name="l00328"></a>00328               ND*i+l,
<a name="l00329"></a>00329               ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*t_ele+3]+l,
<a name="l00330"></a>00330             matele,ADD_VALUES);CHKERRQ(ierr);
<a name="l00331"></a>00331 
<a name="l00332"></a>00332             matele=rhs[0];
<a name="l00333"></a>00333             ierr = MatSetValue(AIpolline,
<a name="l00334"></a>00334               ND*i+l,
<a name="l00335"></a>00335               ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*t_ele+0]+l,
<a name="l00336"></a>00336             matele,ADD_VALUES);CHKERRQ(ierr);
<a name="l00337"></a>00337 
<a name="l00338"></a>00338             matele=rhs[1];
<a name="l00339"></a>00339             ierr = MatSetValue(AIpolline,
<a name="l00340"></a>00340               ND*i+l,
<a name="l00341"></a>00341               ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*t_ele+1]+l,
<a name="l00342"></a>00342             matele,ADD_VALUES);CHKERRQ(ierr);
<a name="l00343"></a>00343 
<a name="l00344"></a>00344             matele=rhs[2];
<a name="l00345"></a>00345             ierr = MatSetValue(AIpolline,
<a name="l00346"></a>00346               ND*i+l,
<a name="l00347"></a>00347               ND*gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*t_ele+2]+l,
<a name="l00348"></a>00348             matele,ADD_VALUES);CHKERRQ(ierr);
<a name="l00349"></a>00349           }
<a name="l00350"></a>00350           <span class="keywordflow">break</span>;
<a name="l00351"></a>00351         }
<a name="l00352"></a>00352       }
<a name="l00353"></a>00353     }
<a name="l00354"></a>00354   }
<a name="l00355"></a>00355 
<a name="l00356"></a>00356   <span class="comment">/* FIXME: large number of mallocs during MatSetValue!? */</span>
<a name="l00357"></a>00357   PetscInfo(0,<span class="stringliteral">&quot;AIpolline matrix assembly complete\n&quot;</span>);
<a name="l00358"></a>00358   ierr = MatAssemblyBegin(AIpolline,MAT_FINAL_ASSEMBLY);CHKERRQ(ierr);
<a name="l00359"></a>00359   ierr = MatAssemblyEnd(AIpolline,MAT_FINAL_ASSEMBLY);CHKERRQ(ierr);
<a name="l00360"></a>00360   ierr = <a class="code" href="printmatinfo_8c.html#a8c62a6053be02438e1bf2da1efa06f1f">PrintMatInfoAll</a>(AIpolline);CHKERRQ(ierr);
<a name="l00361"></a>00361 
<a name="l00362"></a>00362   ierr = VecCreate(PETSC_COMM_WORLD,&amp;VIpolline);CHKERRQ(ierr);
<a name="l00363"></a>00363   <span class="keywordflow">if</span> (!rank) {
<a name="l00364"></a>00364     ierr = VecSetSizes(VIpolline,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*res,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*res);CHKERRQ(ierr);
<a name="l00365"></a>00365   }
<a name="l00366"></a>00366   <span class="keywordflow">else</span> {
<a name="l00367"></a>00367     ierr = VecSetSizes(VIpolline,0,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*res);CHKERRQ(ierr);
<a name="l00368"></a>00368   }
<a name="l00369"></a>00369   ierr = VecSetFromOptions(VIpolline);CHKERRQ(ierr);
<a name="l00370"></a>00370 
<a name="l00371"></a>00371   ierr = PetscFree(sliceele);CHKERRQ(ierr);
<a name="l00372"></a>00372   ierr = PetscFree(vertxyz2);CHKERRQ(ierr);
<a name="l00373"></a>00373 
<a name="l00374"></a>00374 
<a name="l00375"></a>00375   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00376"></a>00376 }
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 
<a name="l00380"></a><a class="code" href="writedatadat_8c.html#a8a2136d4b7b21ac2719c65356c713cbb">00380</a> <span class="keywordtype">int</span> <a class="code" href="magpario_8h.html#a8a2136d4b7b21ac2719c65356c713cbb">WriteDat</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00381"></a>00381 {
<a name="l00382"></a>00382   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00383"></a>00383 
<a name="l00384"></a>00384   <span class="keywordtype">int</span> rank,size;
<a name="l00385"></a>00385   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00386"></a>00386   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00387"></a>00387 
<a name="l00388"></a>00388   <span class="keywordflow">if</span> (doinit) {
<a name="l00389"></a>00389     ierr = <a class="code" href="writedatadat_8c.html#a27c977d96cd920cf08c4c10eb3565f10">WriteDatInit</a>(gdata);CHKERRQ(ierr);
<a name="l00390"></a>00390     doinit=0;
<a name="l00391"></a>00391   }
<a name="l00392"></a>00392   <span class="keywordflow">if</span> (AIpolline==PETSC_NULL) {
<a name="l00393"></a>00393     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00394"></a>00394   }
<a name="l00395"></a>00395 
<a name="l00396"></a>00396   <span class="keywordtype">char</span> fmesh[256];
<a name="l00397"></a>00397   FILE *fd;
<a name="l00398"></a>00398   ierr = PetscSNPrintf(fmesh,255,<span class="stringliteral">&quot;%s.%04i.d&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a2fba16fa768b0451df8fd12ed00a6c6b">simname</a>,gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>);CHKERRQ(ierr);
<a name="l00399"></a>00399   ierr = PetscFOpen(PETSC_COMM_WORLD,fmesh,<span class="stringliteral">&quot;w&quot;</span>,&amp;fd);CHKERRQ(ierr);
<a name="l00400"></a>00400   <span class="keywordflow">if</span> (!rank &amp;&amp; !fd) {
<a name="l00401"></a>00401     SETERRQ1(PETSC_ERR_FILE_OPEN,<span class="stringliteral">&quot;Cannot open %s\n&quot;</span>,fmesh);
<a name="l00402"></a>00402   }
<a name="l00403"></a>00403   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Opening file %s\n&quot;</span>,fmesh);
<a name="l00404"></a>00404 
<a name="l00405"></a>00405 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00406"></a>00406 <span class="preprocessor"></span><span class="comment">/* Htot (useful for measuring &quot;real&quot; field in airbox, where Hexchani==0)</span>
<a name="l00407"></a>00407 <span class="comment">*/</span>
<a name="l00408"></a>00408   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,
<a name="l00409"></a>00409     <span class="stringliteral">&quot;#.%4s %14s %14s %14s\n&quot;</span>
<a name="l00410"></a>00410     <span class="stringliteral">&quot;#.%4s %14s %14s %14s\n&quot;</span>,
<a name="l00411"></a>00411     <span class="stringliteral">&quot;..id&quot;</span>,<span class="stringliteral">&quot;Htot_x&quot;</span>,<span class="stringliteral">&quot;Htot_y&quot;</span>,<span class="stringliteral">&quot;Htot_z&quot;</span>,
<a name="l00412"></a>00412     <span class="stringliteral">&quot;....&quot;</span>,<span class="stringliteral">&quot;(T)&quot;</span>,<span class="stringliteral">&quot;(T)&quot;</span>,<span class="stringliteral">&quot;(T)&quot;</span>
<a name="l00413"></a>00413   );CHKERRQ(ierr);
<a name="l00414"></a>00414 
<a name="l00415"></a>00415   ierr = MatMult(AIpolline,gdata-&gt;<a class="code" href="structGridData.html#a377c12744bdd4ce50a6d4394bd25e49a">VHtot</a>,VIpolline);CHKERRQ(ierr);
<a name="l00416"></a>00416   ierr = VecScale(VIpolline,gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>);CHKERRQ(ierr);
<a name="l00417"></a>00417 
<a name="l00418"></a>00418 <span class="preprocessor">#else</span>
<a name="l00419"></a>00419 <span class="preprocessor"></span><span class="comment">/* magnetization */</span>
<a name="l00420"></a>00420   ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,
<a name="l00421"></a>00421     <span class="stringliteral">&quot;#.%4s %14s %14s %14s\n&quot;</span>
<a name="l00422"></a>00422     <span class="stringliteral">&quot;#.%4s %14s %14s %14s %s\n&quot;</span>,
<a name="l00423"></a>00423     <span class="stringliteral">&quot;..id&quot;</span>,<span class="stringliteral">&quot;Mx&quot;</span>,<span class="stringliteral">&quot;My&quot;</span>,<span class="stringliteral">&quot;Mz&quot;</span>,
<a name="l00424"></a>00424     <span class="stringliteral">&quot;...-&quot;</span>,<span class="stringliteral">&quot;(1)&quot;</span>,<span class="stringliteral">&quot;(1)&quot;</span>,<span class="stringliteral">&quot;(1)&quot;</span>,
<a name="l00425"></a>00425     <span class="stringliteral">&quot;(normalized magnetization, not proportional to Js)&quot;</span>
<a name="l00426"></a>00426   );CHKERRQ(ierr);
<a name="l00427"></a>00427 
<a name="l00428"></a>00428   ierr = MatMult(AIpolline,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,VIpolline);CHKERRQ(ierr);
<a name="l00429"></a>00429 <span class="preprocessor">#endif</span>
<a name="l00430"></a>00430 <span class="preprocessor"></span>
<a name="l00431"></a>00431   <span class="keywordflow">if</span> (!rank) {
<a name="l00432"></a>00432     <span class="keywordtype">int</span> i,j;
<a name="l00433"></a>00433     VecGetSize(VIpolline,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;i);
<a name="l00434"></a>00434     VecGetLocalSize(VIpolline,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;j);
<a name="l00435"></a>00435     <span class="comment">/* the whole vector has to be on the first processor! */</span>
<a name="l00436"></a>00436     assert(i==j);
<a name="l00437"></a>00437     PetscReal *ta_dat;
<a name="l00438"></a>00438     VecGetArray(VIpolline,&amp;ta_dat);
<a name="l00439"></a>00439 
<a name="l00440"></a>00440     <span class="keywordflow">for</span> (i=0; i&lt;j/<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>; i++) {
<a name="l00441"></a>00441       ierr = PetscFPrintf(PETSC_COMM_WORLD,fd,
<a name="l00442"></a>00442         <span class="stringliteral">&quot;  %4d %14e %14e %14e\n&quot;</span>,
<a name="l00443"></a>00443         i,
<a name="l00444"></a>00444         ta_dat[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+0],
<a name="l00445"></a>00445         ta_dat[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+1],
<a name="l00446"></a>00446         ta_dat[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+2]
<a name="l00447"></a>00447       );
<a name="l00448"></a>00448     }
<a name="l00449"></a>00449     VecRestoreArray(VIpolline,&amp;ta_dat);
<a name="l00450"></a>00450   }
<a name="l00451"></a>00451 
<a name="l00452"></a>00452   ierr = PetscFClose(PETSC_COMM_WORLD,fd);CHKERRQ(ierr);
<a name="l00453"></a>00453 
<a name="l00454"></a>00454   <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00455"></a>00455 }
<a name="l00456"></a>00456 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

